<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */
namespace App\Http\Validators;

use App\Http\Base\Validation;

class PopenerimaanioValidator extends Validation
{
    /**
    * this function will call before insert, you can custom as your business requirement
    * @param array $input
    * @return $this
    */
    public function beforeInsert($input){
		if(empty($input["kapalId"])){
			array_push($this->error, ["kapalId" => "cannot be null"]);
		}
		else{
			$lengthkapalid = strlen($input["kapalId"]);
			if($lengthkapalid>19){
			array_push($this->error, ["kapalid" => "value too long"]);
			}
		}
		$kapal= (new \App\Http\Models\KapalModel())
			->getQuery()->where("id","=",$input["kapalId"])->first();
		if(empty($kapal)){
			array_push($this->error, ["kapalId" => "invalid relation"]);
		}
		if(empty($input["locationId"])){
			array_push($this->error, ["locationId" => "cannot be null"]);
		}
		else{
			$lengthlocationid = strlen($input["locationId"]);
			if($lengthlocationid>19){
			array_push($this->error, ["locationid" => "value too long"]);
			}
		}
		$lokasiitem= (new \App\Http\Models\LokasiitemModel())
			->getQuery()->where("id","=",$input["locationId"])->first();
		if(empty($lokasiitem)){
			array_push($this->error, ["locationId" => "invalid relation"]);
		}
		if(empty($input["userId"])){
			array_push($this->error, ["userId" => "cannot be null"]);
		}
		else{
			$lengthuserid = strlen($input["userId"]);
			if($lengthuserid>19){
			array_push($this->error, ["userid" => "value too long"]);
			}
		}
		if(empty($input["rcNumber"])){
			array_push($this->error, ["rcNumber" => "cannot be null"]);
		}
		else{
			$lengthrcNumber = strlen($input["rcNumber"]);
			if($lengthrcNumber>100){
			array_push($this->error, ["rcNumber" => "value too long"]);
			}
		}
		if(empty($input["receiptDate"])){
			array_push($this->error, ["receiptDate" => "cannot be null"]);
		}
		else{
			$lengthreceiptdate = strlen($input["receiptDate"]);
			if($lengthreceiptdate>0){
			array_push($this->error, ["receiptdate" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before update into database, you can custom as your business requirement
    * @param array $input
    * @param $id
    * @return $this
    */
    public function beforeUpdate($input,$id){
		if(empty($input["kapalId"])){
			array_push($this->error, ["kapalId" => "cannot be null"]);
		}
		else{
			$lengthkapalid = strlen($input["kapalId"]);
			if($lengthkapalid>19){
			array_push($this->error, ["kapalid" => "value too long"]);
			}
		}
		if(!empty($input["kapalId"])){
		$kapal= (new \App\Http\Models\KapalModel())
			->getQuery()->where("id","=",$input["kapalId"])->first();
		if(empty($kapal)){
			array_push($this->error, ["kapalId" => "invalid relation"]);
		}
		}
		if(empty($input["locationId"])){
			array_push($this->error, ["locationId" => "cannot be null"]);
		}
		else{
			$lengthlocationid = strlen($input["locationId"]);
			if($lengthlocationid>19){
			array_push($this->error, ["locationid" => "value too long"]);
			}
		}
		if(!empty($input["locationId"])){
		$lokasiitem= (new \App\Http\Models\LokasiitemModel())
			->getQuery()->where("id","=",$input["locationId"])->first();
		if(empty($lokasiitem)){
			array_push($this->error, ["locationId" => "invalid relation"]);
		}
		}
		if(empty($input["userId"])){
			array_push($this->error, ["userId" => "cannot be null"]);
		}
		else{
			$lengthuserid = strlen($input["userId"]);
			if($lengthuserid>19){
			array_push($this->error, ["userid" => "value too long"]);
			}
		}
		if(!empty($input["userId"])){
		$users= (new \App\Http\Models\UsersModel())
			->getQuery()->where("id","=",$input["userId"])->first();
		if(empty($users)){
			array_push($this->error, ["userId" => "invalid relation"]);
		}
		}
		if(empty($input["rcNumber"])){
			array_push($this->error, ["rcNumber" => "cannot be null"]);
		}
		else{
			$lengthrcNumber = strlen($input["rcNumber"]);
			if($lengthrcNumber>100){
			array_push($this->error, ["rcNumber" => "value too long"]);
			}
		}
		if(empty($input["receiptDate"])){
			array_push($this->error, ["receiptDate" => "cannot be null"]);
		}
		else{
			$lengthreceiptdate = strlen($input["receiptDate"]);
			if($lengthreceiptdate>0){
			array_push($this->error, ["receiptdate" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before delete from database, you can custom as your business requirement
    * @param $id
    * @return $this
    */
    public function beforeDelete($id){
	return $this;

    }


}